<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );
class ElternsprechtagadminModelElternsprechtagestbearb extends JModel
{
	var $_est;
	
	function getElternsprechtag()
	{
		$this->_est = ''; 	
		if (!$estid = JRequest::getVar('id')) {
			$auswahl = JRequest::getVar('cid',0,'','array');
			$estid = $auswahl[0];
		}
		$query = 'SELECT * FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
		$this->_db->setQuery($query);
		$this->_est = $this->_db->loadObject();
		if (!$this->_est) {
			$this->_est = new stdClass();
			$this->_est->id = 0;
			$this->_est->name = null;
			$this->_est->startda = date('Y-m-d H:i:s');
			$this->_est->endda = null;
			$this->_est->klasse5 = 1;
			$this->_est->klasse6 = 1;
			$this->_est->klasse7 = 1;
			$this->_est->klasse8 = 1;
			$this->_est->klasse9 = 1;
			$this->_est->klasse10 = 1;
			$this->_est->klasse11 = 1;
			$this->_est->klasse12 = 1;
			$this->_est->klasse13 = 1;
			$this->_est->terminanzahl = null;
			$this->_est->adminmail = null;
			$this->_est->usermail = null;
		}
		if ($this->_est->endda=='0000-00-00 00:00:00') $this->_est->endda = null;
		return $this->_est;
	}
	
	function speichern()
	{
		$est = new stdClass;
		$est->id = (int) JRequest::getVar('id');
		$est->name = JRequest::getVar('name');
		$est->startda = JRequest::getVar('startda');
		$est->endda = JRequest::getVar('endda');
		$est->klasse5 = (int) JRequest::getVar('klasse5');
		$est->klasse6 = (int) JRequest::getVar('klasse6');
		$est->klasse7 = (int) JRequest::getVar('klasse7');
		$est->klasse8 = (int) JRequest::getVar('klasse8');
		$est->klasse9 = (int) JRequest::getVar('klasse9');
		$est->klasse10 = (int) JRequest::getVar('klasse10');
		$est->klasse11 = (int) JRequest::getVar('klasse11');
		$est->klasse12 = (int) JRequest::getVar('klasse12');
		$est->klasse13 = (int) JRequest::getVar('klasse13');
		$est->terminanzahl = (int) JRequest::getVar('terminanzahl');
		$est->adminmail = JRequest::getVar('adminmail');
		$est->usermail = (int) JRequest::getVar('usermail');
		if (!$this->felderueberpruefen($est)) return 'Fehler beim Ausfüllen der Felder!';
		if ($est->id==0) {
			if (!$this->_db->insertObject('#__elternsprechtage',$est)) {
				return 'Fehler beim Speichern1';
			}
			$est->id = $this->getID();
			JRequest::setVar('id',$est->id);
			if (!$this->dbtermineerst($est)) {
				$this->dbtermineloe($est);
				$this->estloe($est->id);
				return 'Fehler beim Speichern2';
			}
			return 'Speichern war erfolgreich';
		} else {
			$this->getElternsprechtag();
			if (!$this->_db->updateObject('#__elternsprechtage',$est,'id')) {
				return 'Fehler beim Speichern3';
			}
			if ($est->terminanzahl != $this->_est->terminanzahl) {
				$this->dbtermineloe($this->_est);
				if (!$this->dbtermineerst($est)) {
					$this->dbtermineloe($est);
					return 'Fehler beim Speichern4';
				}
			}
			return 'Speichern war erfolgreich';
		}
	}
	
	function entfernen()
	{
		$auswahl = JRequest::getVar('cid','','post','array');
		if (!$auswahl[0]) return 'Fehler beim Löschen1';
		foreach ($auswahl as $estid) {
			$query = 'SELECT * FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
			$this->_db->setQuery($query);
			$est = $this->_db->loadObject();
			if (!$this->dbtermineloe($est)) return 'Fehler beim Löschen2';
			$query = 'DELETE FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
			$this->_db->setQuery($query);
			if (!$this->_db->query()) return 'Fehler beim Löschen3';
		}
		return 'Der bzw. die Elternsprechtage wurden gelöscht.';
	}
	
	function dbtermineerst($est)
	{
		$query = "CREATE TABLE #__elternsprechtag_".$est->id."_log (
					id INT NOT NULL AUTO_INCREMENT,
					email VARCHAR(100) NOT NULL,
					date VARCHAR(20) NOT NULL,
					time VARCHAR(20) NOT NULL,
					scid INT NOT NULL,
					leid INT NOT NULL,
					zeid INT NOT NULL,
					geloescht INT NOT NULL,
					PRIMARY KEY (id));";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) return false;
		$query = "CREATE TABLE #__elternsprechtag_".$est->id." (
					id INT NOT NULL AUTO_INCREMENT,
					nachname VARCHAR(100) NOT NULL,
					vorname VARCHAR(100) NOT NULL,
					raum VARCHAR(12) NOT NULL,";
		for ($i=1;$i<=$est->terminanzahl;$i++) {
			$query = $query."termin".$i." VARCHAR(100) NOT NULL,";
		}
		$query = $query."PRIMARY KEY (id));";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) return false;
		return true;
	}
  
	function dbtermineloe($est)
	{
		$query = "DROP TABLE IF EXISTS #__elternsprechtag_".$est->id."_log;";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) return false;
		$query = "DROP TABLE IF EXISTS #__elternsprechtag_".$est->id.";";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) return false;
		return true;
	}
	
	function felderueberpruefen($est)
	{
		if (!$est->name or !$est->terminanzahl) return false;
		if (!(int) $est->terminanzahl) return false;
		return true;
	}

	function estloe($estid)
	{
		$query = 'DELETE FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
		$this->_db->setQuery($query);
		$this->_db->query();
	}

	function getID()
	{
		$query = 'SELECT id FROM #__elternsprechtage';
		$IDs = $this->_getList($query);
		$n = count($IDs)-1;
		return $IDs[$n]->id;
	}
}
