<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );
class ElternsprechtagModelElterndruck extends JModel
{
	var $_name;
	var $_dbtermine;
	var $_dblog;
	var $_klassen;
	var $_sc;
	var $_ze;
	var $_ei;

	function __construct()
	{
		parent::__construct();
		$this->setDatenbanken();
		$this->setSchueler();
		$this->setZeiten();
		$this->setEintraege();
	}
	
	function setDatenbanken()
	{
		if (empty($this->_dbtermine)) {
			$estid = JRequest::getInt('estid');
			$query = 'SELECT * FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
			$this->_db->setQuery($query);
			$est = $this->_db->loadObject();
			$this->_name = $est->name;
			$this->_dbtermine = '#__elternsprechtag_'.$est->id;
			$this->_dblog = '#__elternsprechtag_'.$est->id.'_log';
			$this->_klassen = array();
			for ($i=5;$i<=13;$i++) {
				$key = 'klasse'.$i;
				if ($est->$key==1) $this->_klassen[$i] = '%'.$i.'%';
			}
		}
	}
	
	function getName()
	{
		return $this->_name;
	}

	function getLehrer()
  	{
		$query = 'SELECT id,nachname,vorname,raum FROM '.$this->_dbtermine;
		$this->_db->setQuery($query);
		$le = $this->_db->loadRowList();
  		return $le;
  	}

	function setSchueler()
	{
		$sc = array();
		if ($email = JRequest::getVar('email')) {
			foreach ($this->_klassen as $klasse) {
				$query = 'SELECT * FROM #__schueler WHERE email = '.$this->_db->quote($email).' AND klasse LIKE '.$this->_db->quote($klasse);
				$this->_db->setQuery($query);
				$scneu = $this->_db->loadObjectList();
				$sc = array_merge($sc,$scneu);
			}
		}
		$this->_sc = $sc;
	}
	
	function getSchueler()
	{
		return $this->_sc;
	}

	function setZeiten()
	{
		if (empty($this->_ze)) { 
			$query = 'SELECT * FROM '.$this->_dbtermine.' WHERE id = 1';
			$this->_db->setQuery($query);
			$this->_ze = $this->_db->loadRow();
		}
	}

	function getZeiten()
	{
		return $this->_ze;
	}

	function setEintraege()
	{
		$query = 'SELECT * FROM '.$this->_dblog.' WHERE email = '.$this->_db->quote(JRequest::getVar('email')).' AND geloescht = 0 ORDER BY zeid';
		$this->_db->setQuery($query);
		$this->_ei = $this->_db->loadObjectList();
	}

	function getEintraege()
	{
		return $this->_ei;
	}
}
