<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.modelitem' );
class ElternsprechtagModelElternsprechtag extends JModelItem
{
	var $_name;
	var $_dbtermine;
	var $_dblog;
	var $_adminmail;
	var $_usermail;
	var $_klassen;
	var $_startda;
	var $_endda;
	var $_sc;
	var $_ze;
	var $_te;
	var $_ei;
	var $_max;

	function __construct()
	{
		parent::__construct();
		$this->setDatenbanken();
		$this->setSchueler();
		$this->setZeiten();
		$this->setTermine();
		$this->setEintraege();
		$this->setMaximum();
	}
	
	function setDatenbanken()
	{
		if (empty($this->_dbtermine)) {
			$estid = JRequest::getInt('estid');
			$query = 'SELECT * FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
			$this->_db->setQuery($query);
			$est = $this->_db->loadObject();
			$this->_name = $est->name;
			$this->_dbtermine = '#__elternsprechtag_'.$est->id;
			$this->_dblog = '#__elternsprechtag_'.$est->id.'_log';
			$this->_adminmail = $est->adminmail;
			$this->_usermail = $est->usermail;
			$this->_klassen = array();
			for ($i=5;$i<=13;$i++) {
				$key = 'klasse'.$i;
				if ($est->$key==1) $this->_klassen[$i] = '%'.$i.'%';
			}
			$this->_startda = $est->startda;
			$this->_endda = $est->endda;
		}
	}
	
	function getName()
	{
		return $this->_name;
	}

	function getStartda()
	{
		return $this->_startda;
	}

	function getEndda()
	{
		return $this->_endda;
	}

	function getLehrer()
  	{
		$query = 'SELECT id,nachname,vorname,raum FROM '.$this->_dbtermine;
		$this->_db->setQuery($query);
		$le = $this->_db->loadRowList();
  		return $le;
  	}

	function setSchueler()
	{
		$sc = array();
		if ($email = JRequest::getVar('email')) {
			foreach ($this->_klassen as $klasse) {
				$query = 'SELECT * FROM #__schueler WHERE email = '.$this->_db->quote($email).' AND klasse LIKE '.$this->_db->quote($klasse);
				$this->_db->setQuery($query);
				$scneu = $this->_db->loadObjectList();
				$sc = array_merge($sc,$scneu);
			}
		}
		$this->_sc = $sc;
	}
	
	function getSchueler()
	{
		return $this->_sc;
	}

	function setZeiten()
	{
		if (empty($this->_ze)) { 
			$query = 'SELECT * FROM '.$this->_dbtermine.' WHERE id = 1';
			$this->_db->setQuery($query);
			$this->_ze = $this->_db->loadRow();
		}
	}

	function getZeiten()
	{
		return $this->_ze;
	}
	
	function setTermine()
	{
		if (empty($this->_te)) { 
			$leid = JRequest::getVar('leid','2');
			$query = 'SELECT * FROM '.$this->_dbtermine.' WHERE id = '.$this->_db->quote($leid);
			$this->_db->setQuery($query);
			$this->_te = $this->_db->loadRow();
		}
	}

	function getTermine()
	{
		return $this->_te;
	}

	function setEintraege()
	{
		$query = 'SELECT * FROM '.$this->_dblog.' WHERE email = '.$this->_db->quote(JRequest::getVar('email')).' AND geloescht = 0 ORDER BY zeid';
		$this->_db->setQuery($query);
		$this->_ei = $this->_db->loadObjectList();
	}

	function getEintraege()
	{
		return $this->_ei;
	}
	
	function setMaximum()
	{
		if (count($this->_ei)>=15) $this->_max = 'true';
	}

	function getMaximum()
	{
		return $this->_max;
	}

	function testscid()
	{
		foreach ($this->_sc as $schueler) {
			if ($schueler->id==JRequest::getVar('scid')) return true;
		}
		return false;
	}

	function logalt()
	{
		$query = 'Select * FROM '.$this->_dblog.' WHERE leid = '.$this->_db->quote(JRequest::getVar('leid')).' AND zeid = '.$this->_db->quote(JRequest::getVar('zeid')).' AND geloescht = '.$this->_db->quote(0);
		$this->_db->setQuery($query);
		$logs = $this->_db->loadObjectList();
		foreach ($logs as $log) {
			$log->geloescht = 1;
			$this->_db->updateObject($this->_dblog, $log, 'id');
		}
	}

	function logneu()
	{
		$log = (object) array(
			"id" => NULL,
			"email" => JRequest::getVar('email'),
			"date" => date("d.m.y"),
			"time" => date("H:i:s"),
			"scid" => JRequest::getVar('scid'),
			"leid" => JRequest::getVar('leid'),
			"zeid" => JRequest::getVar('zeid'),
			"geloescht" => 0
		);
		$this->_db->insertObject($this->_dblog,$log);
	}

	function adminmail()
	{
		$this->setEintraege();
		$this->setMaximum();
		if ($this->_max and $this->_adminmail) {
			$mail =& JFactory::getMailer();
			$mail->addRecipient($this->_adminmail);
			$mail->setSubject('Elternsprechtag-Maximum-erreicht');
			$mail->setBody('Der Benutzer '.JRequest::getVar('email').' hat die maximale Anzahl an Terminen belegt.');
			$mail->Send();
		}
	}

	function usermail0()
	{
		if ($this->_usermail==1) {
			$mail =& JFactory::getMailer();
			$mail->addRecipient(JRequest::getVar('email'));
			$mail->setSubject('Elternsprechtag: neuer Termin');
			$mail->setBody('Sie haben um '.$this->_ze[JRequest::getVar('zeid')].' bei '.$this->_te[1].' '.$this->_te[2].' Raum '.$this->_te[3].' einen Termin eingetragen.');
			$mail->Send();
		}
	}

	function usermail1()
	{
		if ($this->_usermail==1) {
			$mail =& JFactory::getMailer();
			$mail->addRecipient(JRequest::getVar('email'));
			$mail->setSubject('Elternsprechtag: Termin gelöscht');
			$mail->setBody('Sie haben den Termin um '.$this->_ze[JRequest::getVar('zeid')].' bei '.$this->_te[1].' '.$this->_te[2].' gelöscht.');
			$mail->Send();
		}
	}
	
	function einfuegen()
	{
		if ($this->testscid() AND JRequest::getVar('zeid')) {
			$n = JRequest::getVar('zeid')-3;
			$key = 'termin'.$n;

			$db =& $this->_db;
			$query = 'SELECT * FROM '.$this->_dbtermine.' WHERE id = '.$db->quote(JRequest::getVar('leid'));
			$db->setQuery($query);
			$te = $db->loadObject();
			$query = "SELECT * FROM #__schueler WHERE id = ".$db->quote(JRequest::getVar('scid'));
			$db->setQuery($query);
			$sc = $db->loadObject();
			
			if (!$te->$key) {
				$te->$key = $sc->name.", ".$sc->klasse;
				$db->updateObject($this->_dbtermine, $te, 'id');
				$this->logneu();
				$this->adminmail();
				$this->usermail0();
			} elseif ($te->$key==$sc->name.", ".$sc->klasse) {
				$te->$key = '';
				$db->updateObject($this->_dbtermine, $te, 'id');
				$this->logalt();
				$this->usermail1();
			}
		}
	}
}
