<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
class ElternsprechtagadminController extends JController
{
	function display($cachable = false)
	{
		JRequest::setVar('view', JRequest::getCmd('view', 'Elternsprechtagadmin'));
		parent::display($cachable);
	}
	
	function __construct()
	{
		parent::__construct();
		$this->registerTask('estneu','estbearb');
	}
	
	function estbearb()
	{
		JRequest::setVar('view','Elternsprechtagestbearb');
		JRequest::setVar('layout','estbearb');
		JRequest::setVar('hidemainmenu',1);
		parent::display();
	}

	function estanwenden()
	{
		$model =& $this->getModel('Elternsprechtagestbearb');
		$msg = $model->speichern();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=estbearb&id='.JRequest::getVar('id'),$msg);
	}

	function estspeichern()
	{
		$model =& $this->getModel('Elternsprechtagestbearb');
		$msg = $model->speichern();
		$this->setRedirect(JRoute::_('index.php?option=com_elternsprechtag'),$msg);
	}
	
	function estentfernen()
	{
		$model =& $this->getModel('Elternsprechtagestbearb');
		$msg = $model->entfernen();
		$this->setRedirect(JRoute::_('index.php?option=com_elternsprechtag'),$msg);
	}

	function log()
	{
		JRequest::setVar('view','Elternsprechtaglog');
		JRequest::setVar('layout','log');
		parent::display();
	}

	function logloeschen()
	{
		$model =& $this->getModel('Elternsprechtaglog');
		$msg = $model->loeschen();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=log&estid='.JRequest::getVar('estid').'&email='.JRequest::getVar('email').'&leid='.JRequest::getVar('leid').'&geloescht='.JRequest::getVar('geloescht'), $msg);
	}

	function logwiederherstellen()
	{
		$model =& $this->getModel('Elternsprechtaglog');
		$msg = $model->wiederherstellen();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=log&estid='.JRequest::getVar('estid').'&email='.JRequest::getVar('email').'&leid='.JRequest::getVar('leid').'&geloescht='.JRequest::getVar('geloescht'), $msg);
	}

	function lehrerverhindert()
	{
		JRequest::setVar('email','');
		$model =& $this->getModel('Elternsprechtaglog');
		$msg = $model->verhindert();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=log&estid='.JRequest::getVar('estid').'&email='.JRequest::getVar('email').'&leid='.JRequest::getVar('leid').'&geloescht='.JRequest::getVar('geloescht'), $msg);
	}

	function lehrerbearbeiten()
	{
		JRequest::setVar('view','Elternsprechtaglehbearb');
		JRequest::setVar('layout','lehbearb');
		JRequest::setVar('hidemainmenu',1);
		parent::display();
	}

	function lehreranwenden()
	{
		$model =& $this->getModel('Elternsprechtaglehbearb');
		$msg = $model->speichern();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=lehrerbearbeiten&estid='.JRequest::getVar('estid').'&email='.JRequest::getVar('email').'&leid='.JRequest::getVar('leid').'&geloescht='.JRequest::getVar('geloescht'), $msg);
	}

	function lehrerspeichern()
	{
		$model =& $this->getModel('Elternsprechtaglehbearb');
		$msg = $model->speichern();
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=log&estid='.JRequest::getVar('estid').'&email='.JRequest::getVar('email').'&leid='.JRequest::getVar('leid').'&geloescht='.JRequest::getVar('geloescht'), $msg);
	}
	
	function inst()
	{
		JRequest::setVar('view','Elternsprechtaginst');
		JRequest::setVar('layout','inst');
		parent::display();
	}

	function schuelererst()
	{
		if (JRequest::getVar('sicher')=='true') {
			$model =& $this->getModel('Elternsprechtaginst');
			if (!$msg = $model->dbschuelerloe()) $msg = $model->dbschuelererst();
		} else $msg = 'Sie müssen die "Sind sie sicher"-Checkbox anklicken.';
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=inst', $msg);
	}

	function schuelerloe()
	{
		if (JRequest::getVar('sicher')=='true') {
			$model =& $this->getModel('Elternsprechtaginst');
			if (!$msg = $model->dbschuelerloe()) $msg = 'Die Datenbank jos_schueler wurde gelöscht.';
		} else $msg = 'Sie müssen die "Sind sie sicher"-Checkbox anklicken.';
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=inst', $msg);
	}

	function esteerst()
	{
		if (JRequest::getVar('sicher')=='true') {
			$model =& $this->getModel('Elternsprechtaginst');
			if (!$msg = $model->dbelternsprechtageloe()) $msg = $model->dbelternsprechtageerst();
		} else $msg = 'Sie müssen die "Sind sie sicher"-Checkbox anklicken.';
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=inst', $msg);
	}

	function esteloe()
	{
		if (JRequest::getVar('sicher')=='true') {
			$model =& $this->getModel('Elternsprechtaginst');
			if (!$msg = $model->dbelternsprechtageloe()) $msg = 'Die Datenbank jos_elternsprechtage wurde gelöscht.';
		} else $msg = 'Sie müssen die "Sind sie sicher"-Checkbox anklicken.';
		$this->setRedirect('index.php?option=com_elternsprechtag&controller=elternsprechtagadmin&task=inst', $msg);
	}
}