<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );
class ElternsprechtagadminModelElternsprechtaglog extends JModel
{
	var $_est;
	var $_le;
	var $_sc;
	var $_ze;
	var $_logs;
	  
	function getElternsprechtag()
	{
		if (empty($this->_est)) { 
			if (!$estid = JRequest::getVar('estid')) {
				$auswahl = JRequest::getVar('cid',0,'','array');
				$estid = $auswahl[0];
			}
			$query = 'SELECT * FROM #__elternsprechtage WHERE id = '.$this->_db->quote($estid);
			$this->_db->setQuery($query);
			$this->_est = $this->_db->loadObject();
		}
		return $this->_est;
	}
	
	function getLehrer()
	{
		if (empty($this->_le)) { 
			$query = 'SELECT id,nachname,vorname FROM #__elternsprechtag_'.$this->_est->id;
			$this->_le = $this->_getList($query);
		}
		return $this->_le;
  	}

  	function getSchueler()
	{
		if (empty($this->_sc)) {
			$query = 'SELECT id,name,klasse FROM #__schueler';
			$this->_sc = $this->_getList($query);
		}
		return $this->_sc;
	}

	function getZeiten()
	{
		if (empty($this->_ze)) { 
			$db =& JFactory::getDBO();
			$query = 'SELECT * FROM #__elternsprechtag_'.$this->_est->id.' WHERE id = 1';
			$db->setQuery($query);
			$this->_ze = $db->loadObject();
		}
		return $this->_ze;
	}

	function getLogs()
	{
		if (empty($this->_logs)) { 
			$query = 'SELECT * FROM #__elternsprechtag_'.$this->_est->id.'_log WHERE';
			if (!JRequest::getVar('geloescht')) {
				$query = $query.' geloescht = '.$this->_db->quote(0);
			} else {
				$query = $query.' geloescht IN ('.$this->_db->quote(0).','.$this->_db->quote(1).')';
			}
			if (JRequest::getVar('email')) $query = $query.' AND email = '.$this->_db->quote(JRequest::getVar('email'));
			if (JRequest::getVar('leid')) $query = $query.' AND leid = '.$this->_db->quote(JRequest::getVar('leid'));
			$query = $query.' ORDER BY id';
			$this->_logs = $this->_getList($query);
		}
		return $this->_logs;
	}

	function loeschen()
	{
		$this->getElternsprechtag();
		$auswahl = JRequest::getVar('cid','','post','array');
		if (!$auswahl[0]) return 'Fehler beim Löschen!';
		foreach ($auswahl as $logid) {
			if (!$log =& $this->getLog($logid)) return 'Fehler beim Löschen!';
			if (!$te =& $this->getTermine($log->leid)) return 'Fehler beim Löschen!';
			$n = $log->zeid-3;
			$key = "termin".$n;
			if ($log->geloescht==0) {
				$te->$key = '';
				$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id, $te, 'id');
				$log->geloescht = 1;
				$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id.'_log', $log, 'id');
				$this->usermail1($log,$te);
			}
		}
		return 'Die gewünschten Termine wurden gelöscht.';
	}

	function getLog($logid)
	{
		$query = 'SELECT * FROM #__elternsprechtag_'.$this->_est->id.'_log WHERE id = '.$this->_db->quote($logid);
		$this->_db->setQuery($query);
		$log = $this->_db->loadObject();
		return $log;
	}

	function getTermine($leid)
	{
		$query = 'SELECT * FROM #__elternsprechtag_'.$this->_est->id.' WHERE id = ' .$this->_db->quote($leid);
		$this->_db->setQuery($query);
		$te = $this->_db->loadObject();
		return $te;
  	}

	function usermail1($log,$te)
	{
		if ($this->_est->usermail==1) {
			$mail =& JFactory::getMailer();
			$mail->addRecipient($log->email);
			$mail->setSubject('Elternsprechtag: Termin gelöscht');
			$mail->setBody('Einer ihrer Termine bei dem Lehrer (der Lehrerin) '.$te->nachname.' '.$te->vorname.' musste vom Betreuer der Elternsprechtaganmeldung gelöscht werden.');
			$mail->Send();
		}
	}

	function wiederherstellen()
	{
		$this->getElternsprechtag();
		$auswahl = JRequest::getVar('cid','','post','array');
		if (!$auswahl[0]) return 'Fehler beim Wiederherstellen1!';
		foreach ($auswahl as $logid) {
			if (!$log =& $this->getLog($logid)) return 'Fehler beim Wiederherstellen2!';
			if (!$te =& $this->getTermine($log->leid)) return 'Fehler beim Wiederherstellen3!';
			$n = $log->zeid-3;
			$key = "termin".$n;
			if ($log->geloescht==1 AND !$te->$key) {
				if (!$sc =& $this->getSc($log->scid)) return 'Fehler beim Wiederherstellen4!';
				$te->$key = $sc->name.", ".$sc->klasse;
				$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id, $te, 'id');
				$log->geloescht = 0;
				$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id.'_log', $log, 'id');
			}
		}
		return 'Die gewünschten Termine wurden wiederhergestellt.';
	}

	function getSc($scid)
	{
		$query = 'SELECT * FROM #__schueler WHERE id = '.$this->_db->quote($scid);
		$this->_db->setQuery($query);
		$sc = $this->_db->loadObject();
		return $sc;
	}

	function verhindert()
	{
		$this->getElternsprechtag();
		$this->getLogs();
		if (!$te =& $this->getTermine(JRequest::getVar('leid'))) return 'Der Lehrer konnte nicht als verhindert eingetragen werden.';
		foreach ($this->_logs as $log) {
			$n = $log->zeid-3;
			$key = "termin".$n;
			if ($log->geloescht==0) {
				$te->$key = '';
				$log->geloescht = 1;
				$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id.'_log', $log, 'id');
				$this->usermail2($log,$te);
			}
		}
		$te->raum = 'verhindert';
		$this->_db->updateObject('#__elternsprechtag_'.$this->_est->id, $te, 'id');
		return 'Der Lehrer wurde als verhindert eingetragen.';
	}

	function usermail2($log,$te)
	{
		if ($this->_est->usermail==1) {
			$mail =& JFactory::getMailer();
			$mail->addRecipient($log->email);
			$mail->setSubject('Elternsprechtag: Termin gelöscht');
			$mail->setBody('Der Lehrer (die Lehrerin) '.$te->nachname.' '.$te->vorname.' ist an dem von Ihnen eingetragenen Termin leider verhindert, deshalb wurde der Termin gelöscht.');
			$mail->Send();
		}
	}
}